﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Buildcraft.Core.Test;
using Buildcraft.Core.PlayerActions;
using Buildcraft.Core.Components;
using Buildcraft.Core.Model;


namespace Buildcraft.AI.Test
{
    [TestClass]
    public class BasicAITests : BaseScenarioTest
    {
        //Tick Action
        protected TickWorldAction tickWorldAction;

        //AI Players
        protected AIPlayer p1AI;
        protected AIPlayer p2AI;

        protected override void InitializationComplete()
        {
            tickWorldAction = Container.RetrieveInstance<TickWorldAction>();
        }



        /// <summary>
        /// Test a line scenario with 2 players
        /// </summary>
        [TestMethod]
        public void BasicAITests_TwoPlayerLine()
        {
            //NOTE: Currently due to the way the game works, it arrives in a deadlock situation, where neither player can get the upper hand.
            Assert.Inconclusive();

            p1AI = new AIPlayer(player1, Container);
            p2AI = new AIPlayer(player2, Container);

            for (int i = 0; i < 10000; i++)
            {
                int frameSize = 5;

                tickWorldAction.TickWorld(frameSize);
                p1AI.Tick(frameSize);
                p2AI.Tick(frameSize);
            }

            Assert.AreEqual(GameState.GameOver, world.GameState);
            Assert.AreEqual(player2, world.Victor);
        }

    }
}
