﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buildcraft.Core.Model;

namespace Buildcraft.AI
{
    public class AINode
    {
        /// <summary>
        /// The game node this AINode represents
        /// </summary>
        public Node GameNode;

        /// <summary>
        /// A list of joins between the AINodes. This saves
        /// having to do a dictionary lookup at each join traversal.
        /// </summary>
        public List<AIJoin> Joins = new List<AIJoin>();
        
        /// <summary>
        /// Is the node friendly.
        /// </summary>
        public bool Friendly;
        
        /// <summary>
        /// The value of the node for this player.
        /// </summary>
        public int Value;

        public override string ToString()
        {
            return string.Format("{0} - {1}", Value, GameNode.ToString());
        }
    }
}
