﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buildcraft.Core.Model;
using Buildcraft.Core.Components;
using Microsoft.VisualStudio.TestTools.UnitTesting;

namespace Buildcraft.Core.Test.ScenarioTests
{
    [TestClass]
    public class UnitMethodScenarioTests : BaseScenarioTest
    {

        //Player Actions
        protected PlayerActions.PlayerActions _playerActions;

        //Nodes
        protected Node _farmNode;

        protected TickWorldAction _tickWorldAction;

        protected override void InitializationComplete()
        {
            //Unpack
            _tickWorldAction = Container.RetrieveInstance<TickWorldAction>();

            _playerActions = new PlayerActions.PlayerActions(player1, Container);
        }



        [TestMethod]
        public void ScenarioTests_BasicSinglePlayer_UnitMethod()
        {
            //NOTE: Currently due to the way the game works, it arrives in a deadlock situation, where neither player can get the upper hand.
            Assert.Inconclusive();

            //Create a basic scenario containing all the different improvements and some workers.
            CreateBasicScenario();

            //Create Farm Task
            var farmer = player1.UnassignedUnits.Where(w => w.TypeInfo == farmUnit).First();
            var result = _playerActions.AssignUnitToTask(_farmNode, farmer, workImprovementUnitTask);
            Assert.AreEqual(TaskValidityState.Ok, result);


            ////Train our Generalist as a solider
            //var generalist = player1.UnassignedWorkers.Where(w => w.TypeInfo == generalWorker).First();
            //result = _playerActions.AddTask(p1Capital, trainSoldierTask, new Worker[] { generalist });
            //Assert.AreEqual(TaskValidityState.Ok, result);

            ////Resources
            //player1.Resources[moneyResource] = 100;
            //player1.Resources[foodResource] = 0;

            ////Tick World for resource production tasks (100)
            //for (int i = 0; i < 10; i++)
            //{
            //    tickWorldAction.TickWorld(10);
            //}

            ////Check Worker Trained and task ended
            //Assert.AreEqual(soldierWorker, generalist.TypeInfo);
            //Assert.AreEqual(0, p1Capital.Tasks.Count);

            ////Check we have resources
            //Assert.AreEqual(100, player1.Resources[moneyResource]);
            //Assert.AreEqual(40, player1.Resources[foodResource]);
            //Assert.AreEqual(soldierWorker, generalist.TypeInfo);

            ////Tick World for worker consumption task (150)
            //for (int i = 0; i < 5; i++)
            //{
            //    tickWorldAction.TickWorld(10);
            //}

            ////Check Resources Updated
            //Assert.AreEqual(81, player1.Resources[moneyResource]);
            //Assert.AreEqual(24, player1.Resources[foodResource]);

            //var workerCount = player1.AllWorkers.Count;

            ////Tick World for second resource production, and worker spawn
            //for (int i = 0; i < 5; i++)
            //{
            //    tickWorldAction.TickWorld(10);
            //}

            ////Check resources
            //Assert.AreEqual(81, player1.Resources[moneyResource]);
            //Assert.AreEqual(64, player1.Resources[foodResource]);

            ////Check worker was produced
            //Assert.AreEqual(workerCount + 1, player1.AllWorkers.Count);

            throw new NotImplementedException();
        }

        private void CreateBasicScenario()
        {
            //Create Farm
            _farmNode = worldManager.AddNode();
            worldManager.SetNodeImprovement(_farmNode, farmImprovement);
            worldManager.SetNodeOwner(_farmNode, player1);

            //Join Nodes (Improvements in triangle around capital)
            worldManager.AddJoin(p1Capital, _farmNode);

            foreach (var unitType in Container.RetrieveAllInstances<UnitTypeInfo>())
            {
                for (int i = 0; i < 2; i++)
                {
                    playerManager.AddUnit(player1, unitType);
                }
            }
        }
    }
}
