﻿using System;
using System.Text;
using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using Buildcraft.Core.TaskProcessors;
using Buildcraft.Core.Interfaces.UnitTasks;
using Buildcraft.Core.Model;

namespace Buildcraft.Core.Test.TaskProcessorTests
{
    /// <summary>
    /// Summary description for UnitSpawnProcessorTests
    /// </summary>
    [TestClass]
    public class UnitSpawnProcessorTests : BaseTest
    {

        protected override void CustomInitialize()
        {
        }

        protected override void ConfigureWorld()
        {
        }

        [TestMethod]
        public void UnitSpawnProcessorTests_GeneralTest()
        {
            //Setup Parts
            var player = CreatePlayer("P1");
            var unitType = new UnitTypeInfo("Type1");
            var resourceType = new ResourceTypeInfo("Resource");

            //Setup Player
            player.Resources[resourceType] = 1;

            //Create and setup processor
            var processor = new UnitSpawnProcessor();
            processor.Initialize(Container);

            processor.SpawnedUnitType = unitType;
            processor.SpawnCost[resourceType] = 1;


            //STEP 1: Process - Can afford to spawn unit
            processor.Process();

            //Check added unit and deducted cost.
            Assert.IsTrue(player.UnassignedUnits.Count == 1);
            Assert.IsTrue(player.Resources[resourceType] == 0);


            //Step 2: Process - Cannot afford to spawn unit
            processor.Process();

            //Check did not add unit and did not deducted cost.
            Assert.IsTrue(player.UnassignedUnits.Count == 1);
            Assert.IsTrue(player.Resources[resourceType] == 0);
        }
    }
}
