﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buildcraft.Core.Model;
using Buildcraft.Core.Components;
using Buildcraft.Core.TaskProcessors;
using Buildcraft.Core.Interfaces;

namespace Buildcraft.Core
{
    public static class ContainerUtilities
    {
        public static void LoadContainer(IBuildcraftContainer container)
        {
            LoadContainer(container, new World());
        }

        public static void LoadContainer(IBuildcraftContainer container, World world)
        {
            //Load World
            container.RegisterInstance<World>(world);

            //Load Core Managers
            container.RegisterInstance<WorldManager>(new WorldManager());
            container.RegisterInstance<PlayerManager>(new PlayerManager());

            //Load World Actions
            container.RegisterInstance<TickWorldAction>(new TickWorldAction());

            //Load Processors
            container.RegisterInstance<ITaskScheduler>(new BasicTaskScheduler(1000));
        }
    }
}
