﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buildcraft.Core.Interfaces.UnitTasks;
using Buildcraft.Core.UnitTasks;
using Buildcraft.Core.PlayerTasks;

namespace Buildcraft.Core.Interfaces
{
    public interface ITaskProcessor
    {
        /// <summary>
        /// Register a new task state bucket with the task processor.
        /// </summary>
        /// <param name="bucket"></param>
        void RegisterStateBucket(IUnitTaskStateBucket bucket);

        /// <summary>
        /// Unregister an existing task state bucket with the task processor.
        /// </summary>
        /// <param name="bucket"></param>
        void UnregisterStateBucket(IUnitTaskStateBucket bucket);


        /// <summary>
        /// Register a new task state with the task processor.
        /// </summary>
        /// <param name="state"></param>
        void RegisterState(IUnitTaskStateItem state);

        /// <summary>
        /// Unregister an existing task state with the task processor.
        /// </summary>
        /// <param name="state"></param>
        void UnregisterState(IUnitTaskStateItem state);


        /// <summary>
        /// Fire the task processor.
        /// </summary>
        void Process();
    }
}
