﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buildcraft.Core.Model;

namespace Buildcraft.Core.Interfaces.UnitTasks.TaskInfo
{
    /// <summary>
    /// Base Interface for any task that is completable.
    /// </summary>
    public interface IUnitTaskCompletable
    {
        /// <summary>
        /// The base duration for any task.
        /// </summary>
        int Duration { get; }
    }

    public interface IUnitTaskTransformUnitTypeBehavior : IUnitTaskCompletable
    {
        /// <summary>
        /// The UnitTypeInfo that the unit will become when the task is complete.
        /// </summary>
        UnitTypeInfo UnitType { get; }
    }

    public interface IUnitTaskApplyEffectBehavior : IUnitTaskCompletable
    {
        /// <summary>
        /// The node effect applied when this task completes.
        /// </summary>
        NodeEffectTypeInfo NodeEffect { get; }
    }

    public interface IUnitTaskRemoveEffect : IUnitTaskCompletable
    {
        /// <summary>
        /// The node effect that gets removed by this task.
        /// </summary>
        NodeEffectTypeInfo NodeEffect { get; }
    }
}
