﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Buildcraft.Core.Model
{
    /// <summary>
    /// This class ecapsulates progress towards a goal over time.
    /// </summary>
    public class Counter
    {
        public int Duration;
        public int Progress;

        public Counter(int duration)
        {
            Start(duration);
        }

        public void Start(int duration)
        {
            Duration = duration;
            Progress = 0;
        }

        public bool Tick(int tick)
        {
            Progress += tick;

            if (Progress >= Duration)
            {
                Progress = 0;
                return true;
            }

            return false;
        }
    }
}
