﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Buildcraft.Core.Model
{
    public enum TaskState
    {
        Paused,
        Working,
        Complete,
        Recycling,
        Failed
    }

    public enum TaskParameterType
    {
        None,
        WorkerType,
        ImprovementType
    }

    public enum TaskValidityState
    {
        /// <summary>
        /// Returned when the validity state passes
        /// </summary>
        Ok,

        TaskAlreadyExistsOnNode,
        InvalidForNode,
        InvalidForWorker,

        TooFewWorkers,
        TooManyWorkers,
        OneOrMoreWorkerIsInvalid,

        NoImprovement,
        WrongImprovement,
        NotAllowedInFriendlyTerritory,
        NotAllowedInEnemyTerritory,

        WorkerNotHighEnoughLevel,
        WorkerIsWrongType,
        InvalidWorkers,

        InvalidParameter,
        ParameterRequired,
        ImprovementAlreadyRepaired,
        ImprovementAlreadySabotaged,
        InvalidParameterType,
        MustBeAdjacentToBorder
    }

    public enum GameState
    {
        InProgress,
        GameOver
    }
}
