﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Buildcraft.Core.Interfaces;

namespace Buildcraft.Core.Model
{
    public class Improvement: ITypedEntity<ImprovementTypeInfo>
    {
        /// <summary>
        /// The type of the improvement.
        /// </summary>
        public ImprovementTypeInfo TypeInfo;

        /// <summary>
        /// The level of the improvement.
        /// </summary>
        public int ImprovementLevel;

        /// <summary>
        /// Set to true if the improvement is sabotaged and does not produce anything.
        /// </summary>
        public bool Sabotaged;

        public override string ToString()
        {
            return string.Format("{0} ({1}) - Sabotaged: {2}", TypeInfo, ImprovementLevel, Sabotaged);
        }

        #region ITypedEntity<ImprovementTypeInfo> Members

        ImprovementTypeInfo ITypedEntity<ImprovementTypeInfo>.TypeInfo
        {
            get { throw new NotImplementedException(); }
        }

        #endregion
    }
}
