﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buildcraft.Core.Interfaces.UnitTasks;
using Buildcraft.Core.UnitTasks;

namespace Buildcraft.Core.Model
{
    public class Node
    {
        /// <summary>
        /// The id of the node.
        /// </summary>
        public int Id;

        /// <summary>
        /// The terrain for the node.
        /// </summary>
        public string Terrain;

        /// <summary>
        /// The improvement that this node has..
        /// </summary>
        public Improvement Improvement;

        /// <summary>
        /// The owner of the node.
        /// </summary>
        public Player Owner;

        /// <summary>
        /// the joins this node connects via.
        /// </summary>
        public List<Join> Joins = new List<Join>();

        /// <summary>
        /// List of tasks that are currently assigned to the node.
        /// </summary>
        public List<NodeTask> Tasks = new List<NodeTask>();
       
        /// <summary>
        /// List of units that are currently assigned to this node.
        /// </summary>
        public IList<Unit> Units = new List<Unit>();

        /// <summary>
        /// List of task states for tasks that are currently being performed on this node.
        /// </summary>
        public IList<IUnitTaskStateBucket> TaskStateBuckets = new List<IUnitTaskStateBucket>();

        public override string ToString()
        {
            return string.Format("{0} - {1}", Owner, Improvement);
        }
    }
}
