﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


namespace Buildcraft.Core.Model
{
    public class NodeTask
    {
        public int TaskId;

        public Node Node;

        public Player Owner;

        public NodeTaskTypeInfo Type;

        /// <summary>
        /// Indicator for whether the task is paused.
        /// </summary>
        public bool Paused = false;

        /// <summary>
        /// Progress through the task
        /// </summary>
        public int Progress;

        public List<Worker> Workers = new List<Worker>();


        public TaskValidityState CheckValidity()
        {
            return this.Type.CheckTaskValidity(Node, Owner, Workers, true);
        }

        public TaskState Tick(int progress)
        {
            return this.Type.Tick(this, progress);
        }

        public void ApplyEffects()
        {
            this.Type.ApplyEffects(this);
        }

        public void RefreshEffects()
        {
            this.Type.RefreshEffects(this);
        }

        public void FireEffects()
        {
            this.Type.FireEffects(this);
        }

        public void RemoveEffects()
        {
            this.Type.RemoveEffects(this);
        }


        public override string ToString()
        {
            return string.Format("{0} ({1} / {2})", Type, Progress, Type.TaskDuration);
        }

    }
}
