﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Buildcraft.Core.Model
{
    public class Player
    {
        /// <summary>
        /// Number of the player
        /// </summary>
        public int Id;

        /// <summary>
        /// Display name of the player
        /// </summary>
        public string Name;

        /// <summary>
        /// A list of nodes belonging to the player
        /// </summary>
        public List<Node> Nodes = new List<Node>();


        /// <summary>
        /// List of all workers.
        /// </summary>
        public List<Worker> AllWorkers = new List<Worker>();

        /// <summary>
        /// Workers who are not assigned.
        /// </summary>
        public List<Worker> UnassignedWorkers = new List<Worker>();


        /// <summary>
        /// List of all units.
        /// </summary>
        public List<Unit> AllUnits = new List<Unit>();

        /// <summary>
        /// List of unassigned units.
        /// </summary>
        public List<Unit> UnassignedUnits = new List<Unit>();


        /// <summary>
        /// List of tasks that are currently assigned to nodes.
        /// </summary>
        public List<NodeTask> NodeTasks = new List<NodeTask>();

        /// <summary>
        /// List of tasks that are currently assigned to the player
        /// </summary>
        public List<PlayerTask> PlayerTasks = new List<PlayerTask>();
        

        /// <summary>
        /// The resource values for this player
        /// </summary>
        public ResourceValueCollection Resources = new ResourceValueCollection();

        /// <summary>
        /// Value store for effects to apply
        /// </summary>
        public EffectValueCollection EffectValues = new EffectValueCollection();

        /// <summary>
        /// The defence for the player
        /// </summary>
        public int Defence;

        public override string ToString()
        {
            return string.Format("{0} ({1})", Name, Id);
        }
    }
}
