﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Buildcraft.Core.PlayerTasks;

namespace Buildcraft.Core.Model
{
    public class PlayerTask
    {
        public int TaskId;

        public Player Owner;

        public int Progress;

        public PlayerTaskTypeInfo Type;

        public TaskState Tick(int progress)
        {
            return this.Type.Tick(this, progress);
        }

        public void ApplyEffects()
        {
            this.Type.ApplyEffects(this);
        }

        public void RefreshEffects()
        {
            this.Type.RefreshEffects(this);
        }

        public void FireEffects()
        {
            this.Type.FireEffects(this);
        }

        public void RemoveEffects()
        {
            this.Type.RemoveEffects(this);
        }

    }
}
