﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buildcraft.Core.Interfaces.UnitTasks.TaskInfo;
using Buildcraft.Core.Model;
using Buildcraft.Core.Interfaces.UnitTasks;
using Buildcraft.Core.Interfaces;
using Buildcraft.Core.UnitTasks;

namespace Buildcraft.Core.Model
{
    public class Unit : ITypedEntity<UnitTypeInfo>
    {
        public int Id;

        public UnitTypeInfo TypeInfo;

        public Player Owner;

        public Node Node;

        /// <summary>
        /// Indicate whether the unit is currently recieving resources for running costs.
        /// </summary>
        public bool IsSupplied;

        /// <summary>
        /// The task state for the task the unit is currently running.
        /// </summary>
        public IUnitTaskStateItem TaskState;


        #region ITypedEntity<UnitTypeInfo> Members

        UnitTypeInfo ITypedEntity<UnitTypeInfo>.TypeInfo
        {
            get { return TypeInfo; }
        }

        #endregion
    }
}
