﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buildcraft.Core.Model;
using Buildcraft.Core.Interfaces;

namespace Buildcraft.Core.Model
{
    public class UnitTypeInfo : ITypeInfo
    {
        public string UnitTypeCode;

        /// <summary>
        /// The rank of workers of this type. Lower ranked units will be removed before higher ones when insufficient resources are available.
        /// </summary>
        public int Rank;

        /// <summary>
        /// The base consumption for each unit of this type.
        /// </summary>
        public ResourceValueCollection Consumption = new ResourceValueCollection();


        public UnitTypeInfo(string unitTypeCode)
        {
            UnitTypeCode = unitTypeCode;
        }

        #region ITypeInfo Members

        public string TypeCode
        {
            get { return UnitTypeCode; }
        }

        #endregion
    }
}
