﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Buildcraft.Core.Model
{
    public class WorkerTypeInfo
    {
        public string WorkerTypeCode;

        /// <summary>
        /// The rank of workers of this type. Lower ranked units will be removed before higher ones when insufficient resources are available.
        /// </summary>
        public int Rank;

        /// <summary>
        /// The resources consumed by this worker type.
        /// </summary>
        public ResourceValueCollection Consumption = new ResourceValueCollection();


        public WorkerTypeInfo(string workerTypeCode)
        {
            WorkerTypeCode = workerTypeCode;
        }

        public override string ToString()
        {
            return WorkerTypeCode.ToString();
        }
    }
}
