﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;


namespace Buildcraft.Core.Model
{
    /// <summary>
    /// The world
    /// </summary>
    public class World
    {
        private int _workerId = 1;
        private int _playerId = 1;
        private int _joinId = 1;
        private int _nodeId = 1;
        private int _taskId = 1;

        public int GetNewWorkerId()
        {
            return _workerId++;
        }

        public int GetNewPlayerId()
        {
            return _playerId++;
        }

        public int GetNewJoinId()
        {
            return _joinId++;
        }

        public int GetNewNodeId()
        {
            return _nodeId++;
        }

        public int GetNewtaskId()
        {
            return _taskId++;
        }


        /// <summary>
        /// The players in the game
        /// </summary>
        public List<Player> Players = new List<Player>();

        /// <summary>
        /// The map of the world
        /// </summary>
        public List<Node> Nodes = new List<Node>();


        /// <summary>
        /// The victor of the game.
        /// </summary>
        public Player Victor = null;

        /// <summary>
        /// The state the game is currently int.
        /// </summary>
        public GameState GameState = GameState.InProgress;
    }
}
