﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buildcraft.Core.Model;

using Buildcraft.Core.Exceptions;

namespace Buildcraft.Core.NodeTasks.Conditions
{
    public interface ICondition
    {
        /// <summary>
        /// The parameter required by this condition. Used to provide options to the player
        /// </summary>
        TaskParameterType ParameterType { get; }

        TaskValidityState CheckNodeValidity(Node node, Player player);

        TaskValidityState CheckWorkerValidity(Node node, Player player, Worker worker);

        TaskValidityState CheckWorkersValidity(Node node, Player player, IEnumerable<Worker> workers);
    }
}
