﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Buildcraft.Core.Model;
using System.Diagnostics;
using Buildcraft.Core.Interfaces;

namespace Buildcraft.Core.NodeTasks.Effects
{
    public class ChangeWorkerTypeEffect : IEffect<NodeTask>, IInitializable
    {
        private IHostNotify _hostNotify;
        private string _workerTypeCode;
        
        public WorkerTypeInfo WorkerType;

        public ChangeWorkerTypeEffect(string workerTypeCode)
        {
            _workerTypeCode = workerTypeCode;
        }

        public void Initialize(IBuildcraftContainer container)
        {
            _hostNotify = container.RetrieveInstance<IHostNotify>();
            WorkerType = container.RetrieveInstance<WorkerTypeInfo>(_workerTypeCode);
        }

        #region IEffect Members

        public void Apply(Model.NodeTask task)
        {
        }

        public void Fire(Model.NodeTask task)
        {
            Debug.Assert(task != null);

            foreach (var worker in task.Workers)
            {
                if (WorkerType == null)
                    throw new NotImplementedException();

                worker.TypeInfo = WorkerType;
            }
        }

        public void Refresh(Model.NodeTask task)
        {
        }

        public void Remove(Model.NodeTask task)
        {
        }

        #endregion
    }
}
