﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buildcraft.Core.Model;
using Buildcraft.Core.Interfaces;

namespace Buildcraft.Core.NodeTasks.Effects
{
    public class SabotageImprovementEffect : IEffect<NodeTask>, IInitializable
    {
        private IHostNotify _hostNotify;

        public void Initialize(IBuildcraftContainer container)
        {
            _hostNotify = container.RetrieveInstance<IHostNotify>();
        }

        #region IEffect Members

        public void Apply(Model.NodeTask task)
        {
        }

        public void Fire(Model.NodeTask task)
        {
            var node = task.Node;

            if (node == null)
                throw new ArgumentException("Task Node is null");

            var improvement = node.Improvement;

            if (node == null)
                throw new ArgumentException("Node Improvement is null");

            improvement.Sabotaged = true;
        }

        public void Refresh(Model.NodeTask task)
        {
        }

        public void Remove(Model.NodeTask task)
        {
        }

        #endregion
    }
}
