﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buildcraft.Core.Model;
using Buildcraft.Core.Components;

using Buildcraft.Core.Interfaces;

namespace Buildcraft.Core.PlayerTasks.Effects
{
    public class WorkerSpawnEffect : IEffect<PlayerTask>, IInitializable
    {
        /// <summary>
        /// The production cost of workers
        /// </summary>
        public ResourceValueCollection ProductionCost = new ResourceValueCollection();

        public WorkerTypeInfo SpawnType;

        private PlayerManager _playerManager;
        private IHostNotify _hostNotify;

        public void Initialize(IBuildcraftContainer container)
        {
            _hostNotify = container.RetrieveInstance<IHostNotify>();
            _playerManager = container.RetrieveInstance<PlayerManager>();
        }

        #region IEffect<PlayerTask> Members

        public void Apply(PlayerTask task)
        {
        }

        public void Fire(PlayerTask task)
        {
            //Determine if production is valid
            foreach (var resource in ProductionCost)
            {
                if (task.Owner.Resources[resource] < ProductionCost[resource])
                    return;
            }

            //Deduct Resources and add worker
            foreach (var resource in ProductionCost)
            {
                task.Owner.Resources[resource] -= ProductionCost[resource];
            }

            var worker = _playerManager.AddWorker(task.Owner, SpawnType);
        }

        public void Refresh(PlayerTask task)
        {
        }

        public void Remove(PlayerTask task)
        {
        }

        #endregion


    }
}
