﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buildcraft.Core.Interfaces;
using Buildcraft.Core.Model;

namespace Buildcraft.Core.TaskProcessors
{
    public class UnitConsumptionProcessor : ITaskProcessor, IInitializable
    {
        private World _world;

        #region IInitializable Members

        public void Initialize(IBuildcraftContainer container)
        {
            _world = container.RetrieveInstance<World>();
        }

        #endregion

        #region ITaskProcessor Members

        public void RegisterStateBucket(UnitTasks.IUnitTaskStateBucket bucket)
        {
        }

        public void UnregisterStateBucket(UnitTasks.IUnitTaskStateBucket bucket)
        {
        }


        public void RegisterState(UnitTasks.IUnitTaskStateItem state)
        {
        }

        public void UnregisterState(UnitTasks.IUnitTaskStateItem state)
        {
        }


        public void Process()
        {
            //Loop Through players
            foreach (var player in _world.Players)
            {
                //Loop Through Units
                foreach (var unit in player.AllUnits)
                {
                    var consumption = unit.TypeInfo.Consumption;
                    var resources=  player.Resources;

                    if (resources.CanSubtract(consumption))
                    {
                        resources.Subtract(consumption);
                        unit.IsSupplied = true;
                    }
                    else
                        unit.IsSupplied = false;
                }
            }
        }

        #endregion
    }
}
