﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buildcraft.Core.Model;

namespace Buildcraft.Core.UnitTasks.AttackNode
{
    public interface IAttackNodeTaskState :
        IUnitTaskStateItemRunningCost,
        IUnitTaskStateItemNodeAttack
    {
    }

    public class AttackNodeTaskState : UnitTaskStateItemBase<AttackNodeTaskTypeInfo>, IAttackNodeTaskState
    {
        private ResourceValueCollection _runningCost;
        private int _attackPower;

        public AttackNodeTaskState(AttackNodeTaskTypeInfo taskInfo, Node node, Unit unit)
            :base(taskInfo, node, unit)
        {
            _runningCost = new ResourceValueCollection();
            _attackPower = 0;
        }

        public override void Recalculate()
        {
            _attackPower = _taskInfo.CalculatePower(_node, _unit);
            _taskInfo.CalculatorRunningCost(_node, _unit, _runningCost);
        }

        #region IUnitTaskStateItemRunningCost Members

        public ResourceValueCollection RunningCost
        {
            get { return _runningCost; }
        }

        public bool IsPaidFor
        {
            get;
            set;
        }

        #endregion

        #region IUnitTaskStateItemNodeAttack Members

        public float Power
        {
            get { return _attackPower; }
        }

        #endregion
    }
}
