﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buildcraft.Core.Model;

namespace Buildcraft.Core.UnitTasks.DefendNode
{
    public interface IDefendNodeTaskState :
        IUnitTaskStateItemRunningCost,
        IUnitTaskStateItemNodeDefence
    {
    }

    public class DefendNodeTaskState : UnitTaskStateItemBase<DefendNodeTaskTypeInfo>, IDefendNodeTaskState
    {
        private ResourceValueCollection _runningCost;
        private int _defencePower;

        public DefendNodeTaskState(DefendNodeTaskTypeInfo taskInfo, Node node, Unit unit)
            : base(taskInfo, node, unit)
        {
            _runningCost = new ResourceValueCollection();
            _defencePower = 0;
        }

        public override void Recalculate()
        {
            _defencePower = _taskInfo.CalculatePower(_node, _unit);
            _taskInfo.CalculatorRunningCost(_node, _unit, _runningCost);
        }

        #region IUnitTaskStateItemRunningCost Members

        public ResourceValueCollection RunningCost
        {
            get { return _runningCost; }
        }

        public bool IsPaidFor
        {
            get;
            set;
        }

        #endregion

        #region IUnitTaskStateItemNodeDefence Members

        public float Power
        {
            get { return _defencePower; }
        }

        #endregion
    }
}
