﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Buildcraft.Core.Model;
using Buildcraft.Core.UnitTasks;

namespace Buildcraft.Core.UnitTasks
{
    /// <summary>
    /// A task state that has a running cost.
    /// </summary>
    public interface IUnitTaskStateBucketRunningCost :IUnitTaskStateBucket
    {
        /// <summary>
        /// The running cost per cycle for the task.
        /// </summary>
        ResourceValueCollection RunningCost { get; }

        /// <summary>
        /// Get or set whether the task state has been paid for for this process cycle, and is active
        /// </summary>
        bool IsPaidFor { get; set; }
    }
}
