﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows.Media;
using Buildcraft.Core.Model;

namespace Buildcraft
{
    public static class Constants
    {
        private static Brush NEUTRAL = new SolidColorBrush(Colors.Black);

        private static List<Brush> PlayerBrushes = new List<Brush>()
        {
            new SolidColorBrush(Colors.Red), 
            new SolidColorBrush(Colors.Blue), 
            new SolidColorBrush(Colors.Green), 
            new SolidColorBrush(Colors.Yellow)
        };

        public static Brush GetPlayerBrush(Player player)
        {
            if (player == null)
                return NEUTRAL;

            return PlayerBrushes[player.Id - 1];
        }
    }
}
