﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Buildcraft.Core.Model;

namespace Buildcraft.Controls
{
    /// <summary>
    /// Interaction logic for NodeDetails.xaml
    /// </summary>
    public partial class NodeDetails : UserControl, IRebindable
    {
        private Node _gameNode;

        private Dictionary<NodeTask, NodeTaskDetails> _uiNodeTaskdetailsDictionary = new Dictionary<NodeTask, NodeTaskDetails>();

        public NodeDetails()
        {
            InitializeComponent();
        }

        public Node GameNode
        {
            get { return _gameNode; }
            set
            {
                _gameNode = value;
                Rebind();
            }
        }

        public void Rebind()
        {
            nodeBorder.BorderBrush = Constants.GetPlayerBrush(_gameNode.Owner);

            StringBuilder sb = new StringBuilder();

            sb.AppendFormat("{0}{1}", _gameNode.Improvement, Environment.NewLine);

            nodeDetailsTextBox.Text = sb.ToString();
        }


        public void AddNodeTask(NodeTask task)
        {
            var details = new NodeTaskDetails();
            details.Task = task;
            details.Height = 10;
            details.Width = 10;

            _uiNodeTaskdetailsDictionary.Add(task, details);

            tasksStackPanel.Children.Add(details);
        }

        public void RemoveNodeTask(NodeTask task)
        {
            var details = _uiNodeTaskdetailsDictionary[task];

            _uiNodeTaskdetailsDictionary.Remove(task);
            tasksStackPanel.Children.Remove(details);
        }

    }
}
