﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using Buildcraft.Core.Model;

namespace Buildcraft.Controls
{
    /// <summary>
    /// Interaction logic for PlayerDetails.xaml
    /// </summary>
    public partial class PlayerDetails : UserControl, IRebindable
    {
        private Player _player;

        public PlayerDetails()
        {
            InitializeComponent();
        }

        public Player Player
        {
            get { return _player; }
            set 
            { 
                _player = value;
                Rebind();
            }
        }

        public void Rebind()
        {
            this.playerBorder.BorderBrush = Constants.GetPlayerBrush(_player);

            StringBuilder sb = new StringBuilder();

            sb.AppendFormat("{0}{1}", Player.ToString(), Environment.NewLine);
            sb.AppendFormat("Workers: {0}{1}", Player.AllWorkers.Count, Environment.NewLine);
            sb.AppendFormat("U. Workers: {0}{1}", Player.UnassignedWorkers.Count, Environment.NewLine);

            foreach (var resource in Player.Resources)
            {
                sb.AppendFormat("{0}: {1}{2}", resource, Player.Resources[resource], Environment.NewLine);
            }

            textBlock.Text = sb.ToString();
        }
    }
}
